/*
*   Byte-oriented AES-256 implementation.
*   All lookup tables replaced with 'on the fly' calculations.
*
*   Copyright (c) 2007-2009 Ilya O. Levin, http://www.literatecode.com
*   Other contributors: Hal Finney
*
*   Permission to use, copy, modify, and distribute this software for any
*   purpose with or without fee is hereby granted, provided that the above
*   copyright notice and this permission notice appear in all copies.
*
*   THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
*   WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
*   MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
*   ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
*   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
*   ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
*   OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

#include <stdint.h>
#include <stddef.h>

#ifndef I__HASH_H__
#define I__HASH_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MAX_EDGES
#define MAX_EDGES	100
#endif

uint32_t hash_djb2(void *buf, size_t len);

void ir_symbolize(uint8_t *buf, size_t len, char *syms, size_t sym_len);
uint32_t ir_hash(uint8_t *buf, size_t len);
uint32_t ir_hash_safe(uint8_t *buf, size_t len);

uint32_t ir_hash_16(uint16_t *buf, size_t len);

uint32_t ir_test(uint16_t *buf, size_t len);

#ifdef __cplusplus
}
#endif

#endif /* I__HASH_H__*/
